﻿// -----------------------------------------------------------------------
// <copyright file="XamDatagridControl.cs" company="Microsoft">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace BindingIssue.UserControls
{
    using System;
    using Infragistics.Windows;
    using Infragistics.Windows.DataPresenter;
    using System.Windows;
    using System.Windows.Controls;
    using Infragistics.Controls.Menus;
    using Infragistics.Documents.Excel;
    using Infragistics.Windows.DataPresenter.ExcelExporter;
        
    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class XamDatagridControl : XamDataGrid
    {
        private Label lblFilteredItems = new Label();
        private XamContextMenu xamContextMenu1 = new XamContextMenu();
        private XamMenuItem menuItemCopy = new XamMenuItem { Header = "Copy" };
        private XamMenuItem menuItemExportToExcel = new XamMenuItem { Header = "Export To Excel" };
        private XamDataGrid myDataGrid = new XamDataGrid();

        public XamDatagridControl()
        {
            this.Loaded += new RoutedEventHandler(this.AwrdsDataGrid_Loaded);
            this.RecordFilterChanged += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordFilterChangedEventArgs>(AwrdsDataGrid_RecordFilterChanged);
        }

        private void AwrdsDataGrid_Loaded(object sender, RoutedEventArgs e)
        {
            this.myDataGrid = sender as XamDataGrid;

            /* I would like to do a check if any menu items exist and 
             * if not add the Copy and Export To Excel menu items*/

            Grid grid = Utilities.GetDescendantFromType(myDataGrid, typeof(Grid), false) as Grid;

            if (grid != null && grid.Children.Count < 2)
            {
                grid.RowDefinitions.Add(new RowDefinition { Height = new GridLength(1, GridUnitType.Auto) });

                Grid DynamicGrid = new Grid();
                DynamicGrid.HorizontalAlignment = HorizontalAlignment.Stretch;
                DynamicGrid.VerticalAlignment = VerticalAlignment.Top;

                RowDefinition gridRow1 = new RowDefinition { Height = new GridLength(1, GridUnitType.Auto) };
                DynamicGrid.RowDefinitions.Add(gridRow1);

                Grid.SetRow(lblFilteredItems, 0);
                DynamicGrid.Children.Add(lblFilteredItems);

            }
        }

        void AwrdsDataGrid_RecordFilterChanged(object sender, Infragistics.Windows.DataPresenter.Events.RecordFilterChangedEventArgs e)
        {
            XamDataGrid myGrid = sender as XamDataGrid;
            string results = string.Empty;

            if (myGrid.Records.Count > 0 && myGrid.Records != null)
            {
                foreach (RecordFilter filter in myGrid.FieldLayouts[0].RecordFilters)
                {
                    if (filter.Conditions.Count > 0)
                    {
                        results += filter.FieldName + ",";
                    }
                }
                lblFilteredItems.Content = "Filtered Fields: " + results;
                lblFilteredItems.VerticalAlignment = VerticalAlignment.Bottom;
                lblFilteredItems.HorizontalAlignment = HorizontalAlignment.Left;
            }
        }

        private void MenuItemExportToExcel_Click(object sender, EventArgs e)
        {
            // Establish the file name to use for the export.
            string fileName = "Workbook1.xlsx";

            try
            {
                // Get the instance of the DataPresenterExcelExporter defined in the Page's resources and call its Export
                // method passing in the XamDataGrid we want to export, the name of the file we would like
                // to export to and the format of the Workbook we want to Exporter to create.
                DataPresenterExcelExporter exporter = (DataPresenterExcelExporter)this.TryFindResource("Exporter");
                ExportOptions options = new ExportOptions();
                options.FileLimitBehaviour = FileLimitBehaviour.ThrowException;
                exporter.Export(this.myDataGrid, fileName, WorkbookFormat.Excel2007, options);
                System.Diagnostics.Process p = new System.Diagnostics.Process();
                p.StartInfo.FileName = fileName;
                p.Start();
            }
            catch (Exception ex)
            {
                // It's possible that the exporter does not have permission to write the file, so it's generally
                // a good idea to account for this possibility.
                MessageBox.Show(ex.Message);

                return;
            }
        }

        private void MenuItemCopy_Click(object sender, EventArgs e)
        {
            this.myDataGrid.ExecuteCommand(DataPresenterCommands.Copy);
        }
    }
}
